/****************************************************************************
ipw.h

Wed 4/04/2007 12:39 pm    creation.

****************************************************************************/

#ifndef IPW_H
#define IPW_H

/****************************************************************************
****************************************************************************/
#include "managed.h"  //sadly failed dreams of .NET glory.

/****************************************************************************
****************************************************************************/
#define jYES (1)

#define jNO (0)

/****************************************************************************
Fri 7/13/2007 5:12 pm. off the dont_quit option.
****************************************************************************/
#define DONT_QUIT jNO

/****************************************************************************
****************************************************************************/
#include <stdio.h>
#include <vector>

#include "tripe.h"

#include "jini.h"

/****************************************************************************
****************************************************************************/
extern char **__Jargv;
extern int  __Jargc;

/****************************************************************************
****************************************************************************/
#define _f    //nada.
#define _v

using namespace std;
using namespace jIni_space;

/****************************************************************************
decide which encryption code to steal. See ipwrij.cpp for pitiful reflections.
****************************************************************************/

typedef int (*OCRYP_FUNC)(unsigned char);
typedef int (*ICRYP_FUNC)(void);

#define ENC0 jNO      //the wandering web debris encryption.

#define RIJNDAEL jYES //the official public domain version...

#define RIJ_ENC0 (ENC0 && RIJNDAEL)

#if RIJ_ENC0

  extern int (*test_e_d)(char *iname, char *crypt_name, char *o_name) ;

  extern int (*test_e_d_a)(char *iname, char *crypt_name, char *o_name) ;

  bool list_encrypt_file(const char *akey, const char *crypt_name, bool crypt =
  true);

  bool file_decrypt_list(const char *akey, const char *crypt_name,
  bool crypt = true);

  extern string (*encrypt_string)(const string &s);

#else

  #if RIJNDAEL
    #define test_e_d            rij_test_e_d
    #define test_e_d_a          rij_test_e_d_a
    #define list_encrypt_file   rij_list_encrypt_file
    #define file_decrypt_string rij_file_decrypt_string
    #define file_decrypt_list   rij_file_decrypt_list
    #define encrypt_string      rij_encrypt_string

  #endif

  #if ENC0
    #define test_e_d            enc0_test_e_d
    #define test_e_d_a          enc0_test_e_d_a
    #define list_encrypt_file   enc0_list_encrypt_file
    #define file_decrypt_string enc0_file_decrypt_string
    #define file_decrypt_list   enc0_file_decrypt_list
    #define encrypt_string      enc0_encrypt_string

  #endif

#endif

#if RIJNDAEL

  int rij_test_e_d(char *iname, char *crypt_name, char *o_name);
  int rij_test_e_d_a(char *iname, char *crypt_name, char *o_name);
  string rij_encrypt_string(const string &s);

  bool rij_list_encrypt_file(const char *akey, const char *crypt_name, bool
  crypt = true);

  bool rij_file_decrypt_list(const char *akey, const char *crypt_name, bool
  crypt = true);

  string rij_encrypt_string(const string &s);

#endif

#if ENC0

  int enc0_test_e_d(char *iname, char *crypt_name, char *o_name);
  int enc0_test_e_d_a(char *iname, char *crypt_name, char *o_name);
  string enc0_encrypt_string(const string &s);

  bool enc0_list_encrypt_file(const char *akey, const char *crypt_name, bool
  crypt = true);

  bool enc0_file_decrypt_list(const char *akey, const char *crypt_name, bool
  crypt = true);

  string enc0_encrypt_string(const string &s);

#endif


/****************************************************************************
The sacred ascii keys. This stuff will be stored like

    titl:amazon
    logi:owen_bda4@yahoo.com
    pass:bingobango
    misc:blah blah
    exec:www.amazon.com
    comm:Here is a comment. It'll be shown here|Rwith encoded line
    returns see.|R    and maybe I dunno.

****************************************************************************/
#define tTITL "titl:"
#define tLOGI "logi:"
#define tPASS "pass:"
#define tMISC "misc:"
#define tEXEC "exec:"
#define tCOMM "comm:"
#define tLENGTH (5)

/****************************************************************************
****************************************************************************/
#include "ipw.p"

/****************************************************************************
****************************************************************************/
#endif    //#ifndef IPW_H.
