/* FILE: ipw.cpp *****************************/
/* FILE: ipwi.cpp *****************************/
int interactive(void);
/* FILE: ipwmod.cpp *****************************/

class jpw {
//  private:  //I know I'm suppose to do getters but to hoo with it.
  public:
  string
  title,login,password,misc,execute,comment;

  public:
  bool ascii_jpw(JSTRINGLIST ascii_record);
  //key:drivel form, i.e. "title:amazon" etc.

  JSTRINGLIST jpw_ascii(void);
  //returns key:drivel form.

  bool operator==(jpw &a);
  bool operator!=(jpw &a);

  ~jpw();   //let's destruct.

};


typedef vector<jpw> JPWBUNCH;

extern JPWBUNCH Gthelist;
extern jpw *Gtherecord;
extern int Gtheindex;
string j_escape(string s);
string j_ascii(string s, bool shortlines = false);
void sortthelist(void);
JPWBUNCH::iterator findjpw(JPWBUNCH &j, char *title);
int findpw_record(const char *title);
void begin_ipw(void);
jpw *blankjpw(void);
jpw *examplejpw(void);
string random_password(void);
int search(int startindex, bool login_password, char *what, char
**section=NULL);
string httpize(const char *what);
extern char THEKEY[];
extern int from_list_count;
/* FILE: ipwops.cpp *****************************/
char *versionoid(void);

typedef struct {

  bool debug;

  bool dont_ascii;  //MUST be set if we are not to save ascii version.
  bool dont_ascii_encrypt;  //set to save encrypted as binary.

  string password,
  dataname,
  asciiname;

#if DONT_QUIT
  bool dont_quit;
#endif

  JSTRINGLIST *clips;

  string selection;
  bool dont_select;

} OPTIONS;

struct dirt {
  private:
  bool is_dirty;
  public:
  void changedData(void);
  void clean(void);
  bool dirty(void);
};
extern dirt dirty;
extern OPTIONS Goptions;
extern bool Gneed_password;
void setGpassword(const string &s, bool beDirty = true);
bool chkGpassword(const string &s);
void setininame(char *who);
char *getininame(void);
void getdata(void);
extern string ini_at;
void getoptions(void);
void putoptions(void);
void finishoptions(void);
char *nix_dir(void);
string ipwrut(void);
string ipwinidir(void);
string def_ininame(void);
/* FILE: ipwrij.cpp *****************************/
/* FILE: ipwsbrs.cpp *****************************/
extern char Gslashcharacter;
extern char Gslashs[];
char jlastchar(string s);
string jslash(string s);
string junslash(string s);
void jsplit_path(string path, string &front, string &last);
string jlast_path(string path);
void jsplit_ext(const string path, string &front, string &ext);
char *re_ext(const char *p, const char *e);
string jpgmdir(void);
string jpgmdirize(const string &s);
void getreturn(void);
char *j_cwd(void);
string dehomeize(string s);
string j_path(string what);
string IntToHexString(const int &i);
string IntToOctString(const int &i);
char *jgetenv(const char *what);
void free_cstr_dup(char **p, const char *what);
bool isdir(const char *p);
int exist(const char *name);
string decontrol(const string &s);
char *stristr(const char *t, const char *what);
void mustopen(FILE **f, char *name, char *mode);
