/****************************************************************************
jini_sbrs.cpp
Wed 1/31/2007 2:23 pm   creation.

These are the subroutines necessary for the jini code. I couldda put them in
there, but it didn't feel right.

****************************************************************************/
#include "jini_sbrs.h"

#ifdef _MSC_VER
  #define stricmp _stricmp
#endif

namespace jIni_space {
/****************************************************************************
****************************************************************************/


/****************************************************************************
Wed 1/31/2007 2:52 pm. Incredibly, there is apparently *no* EZ way to convert
string to int. ... Confirming, incidentally, my suspicions about C--, as I
call it; a working actually-used language, after all these years, would have,
built-in to the string class, such conversions. Somehow. ...

... So *my* StringToInt tries to convert things like "-12345 bingo " i.e.
ignoring any trailing non-numbers.
****************************************************************************/

int StringToInt(const std::string &s) {
  int val;
  unsigned int i=0;

  switch(s.c_str()[0]) {
    case '+':
    case '-': i = 1;
  }

  for (; i<s.length(); ++i) {
    if (!isdigit(s.c_str()[i]))
    break;
  }

//i now equals the end of the numbers.
  std::stringstream myStream(s.substr(0,i));

  if (myStream>>val)
  return val;
  else
  return 0; //whatever.
}

std::string IntToString(const int &i) {
  std::stringstream myStream;

  myStream << i;

  return myStream.str();

}

/****************************************************************************
****************************************************************************/
void freeandnil(char **s) {
  if (*s)
  free(*s);

  *s = NULL;
}

/****************************************************************************
Thu 2/01/2007 4:30 pm. So apparently it is sinful in c-- land to compare the
case of two characters -- I suppose because they might be chinese and that
might be offensive.... So jstringeq returns true if one and two are the
same, disregarding case! ... Ohhhh what I said!

Thu 5/10/2007 11:58 am. Idiot; turned-out there *was* stricmp, it's just
hiding as strcasecmp. Sometimes. Microsoft is sort-of promising to hide it as
stricmp, but we'll burn that bridge when we come to it....
****************************************************************************/

bool jstringeq(std::string one, std::string two) {

  return
  !(stricmp(one.c_str(),two.c_str()));

#if 0
  if (one==two)
  return true;

  if (one.length() != two.length())
  return false;

//well that covers most cases. Now the sad part....
  unsigned int i;

  for (i=0; i<one.length(); ++i) {
    if (
    tolower(one.c_str()[i])
    !=
    tolower(two.c_str()[i])
    )
    return false;
  }
  return true;
#endif

}

/****************************************************************************
Remove nasty ^M from string?
****************************************************************************/

void decontrolM(std::string &s) {
  if (!s.length())
  return;

  std::string::iterator i=s.end();

  --i;    //look at last character.
  if (*i < ' ') {
    s.erase(i);
  }

}


/****************************************************************************
****************************************************************************/
} //namespace jIni_space.
/****************************************************************************
****************************************************************************/


