/****************************************************************************
ipwmod.cpp
Mon 5/14/2007 12:38 pm  creation

Supposed to contain the "model" -- what does the work --  C++ class guts of
this ridiculous project.

****************************************************************************/
#include "ipw.h"

/****************************************************************************
The comments: it's supposed to be able to contain line-endings and perhaps
other drivel, encoded/decoded by an escape system. It is assumed that all
records stored in a jpw object have the comment encoded. See the utility
functions j_escape/j_ascii

_copy

class jpw {
//  private:  //I know I'm suppose to do getters but to hoo with it.
  public:
  string
  title,login,password,misc,execute,comment;

  public:
  bool ascii_jpw(JSTRINGLIST ascii_record);
  //key:drivel form, i.e. "title:amazon" etc.

  JSTRINGLIST jpw_ascii(void);
  //returns key:drivel form.

  bool operator==(jpw &a);
  bool operator!=(jpw &a);

  ~jpw();   //let's destruct.

};


typedef vector<jpw> JPWBUNCH;

_uncopy

//typedef list<jpw> JPWLIST;


****************************************************************************/
_v JPWBUNCH Gthelist;     //this is the only list. So sue me.
_v jpw *Gtherecord=blankjpw();
                          //set by various folk to the current record.
_v int Gtheindex;         //etc.

bool jpw::ascii_jpw(JSTRINGLIST ascii_record) {
  JSTRINGLIST::iterator i;

  title=login=password=misc=execute=comment="";

  for (i=ascii_record.begin(); i!=ascii_record.end(); ++i) {
    if (i->substr(0,tLENGTH)==tTITL)
    title = i->substr(tLENGTH);

    if (i->substr(0,tLENGTH)==tLOGI)
    login = i->substr(tLENGTH);

    if (i->substr(0,tLENGTH)==tPASS)
    password = i->substr(tLENGTH);

    if (i->substr(0,tLENGTH)==tMISC)
    misc = i->substr(tLENGTH);

    if (i->substr(0,tLENGTH)==tEXEC)
    execute = i->substr(tLENGTH);

    if (i->substr(0,tLENGTH)==tCOMM)
    comment = i->substr(tLENGTH);
  }

  return true;
}

JSTRINGLIST jpw::jpw_ascii(void) {
  JSTRINGLIST t;
  t.push_back((string)tTITL + title);
  t.push_back((string)tLOGI + login);
  t.push_back((string)tPASS + password);
  t.push_back((string)tMISC + misc);
  t.push_back((string)tEXEC + execute);
  t.push_back((string)tCOMM + comment);

  return t;
}

/****************************************************************************
encode escape characters. Make \ns disappear.
****************************************************************************/
#define jECHAR '|'
//#define sjECHAR "|"

_f string j_escape(string s) {
  string d;
  string::iterator i;

  for (i=s.begin(); i!=s.end(); ++i) {
    switch (*i) {
      case '\n':
      d.push_back(jECHAR);
      d.push_back('R');
      break;

      case jECHAR:
      d.push_back(jECHAR);
      d.push_back(jECHAR);
      break;

      default:
      if (*i<' ')
      break;   //dump other controls.

      d.push_back(*i);
      break;
    }
  }

  return d;
}

/****************************************************************************
_copy
string j_ascii(string s, bool shortlines = false);
_uncopy

decode escape characters.
****************************************************************************/

string j_ascii(string s, bool shortlines) {
  string d;
  string::iterator i;
  int count=8;

  for (i=s.begin(); i!=s.end(); ++i) {

    if (*i==jECHAR) {
      ++i;
      switch (*i) {
        case 'R':
        d.push_back('\n');
        count = 0;
        continue; //for

        case jECHAR:
        d.push_back(jECHAR);
        ++count;
        continue;

        default:
        continue; //for; throw-away illegal escapes.
      }
    }

  //if not escape.

    if (
    (*i == ' ') &&
    shortlines &&
    (count>60)
    ) {
      d.push_back('\n');
      count = 0;
    }
    else {
      d.push_back(*i);
      ++count;
    }
  }

  return d;
}

/****************************************************************************
****************************************************************************/

#if 0
static bool jpwgt(const jpw &a, const jpw &b) {
  return
  stricmp(a.title.c_str(),b.title.c_str()) > 0;
}

static bool jpwle(const jpw &a, const jpw &b) {
  return
  stricmp(a.title.c_str(),b.title.c_str()) <= 0;
}

#endif

static bool jpwlt(const jpw &a, const jpw &b) {
  return
  stricmp(a.title.c_str(),b.title.c_str()) < 0;
}

#define SHOW_TITLES NO

#if SHOW_TITLES
void show_titles(void) {
  int i;
  for (i=0; i<Gthelist.size(); ++i)
  printf("%d:%s ",i,Gthelist[i].title.c_str());
  printf("\n");
}
#endif

_f void sortthelist(void) {
//  j.sort(jpwgt);
/****************************************************************************
comp
    Comparison function object that, taking two values of the same type than
those contained in the range, returns true if the first argument goes before
the second argument in the specific strict weak ordering it defines, and false
otherwise.
****************************************************************************/

#if SHOW_TITLES
  if (Goptions.debug) {
    show_titles();
  }
#endif

  sort(Gthelist.begin(),Gthelist.end(),/*jpwgt oops* jpwle* oops again?*/
  jpwlt);

#if SHOW_TITLES
  if (Goptions.debug) {
    show_titles();
  }
#endif
}

#ifdef DIDNT_USE_THIS
_f JPWBUNCH::iterator findjpw(JPWBUNCH &j, char *title) {
  JPWBUNCH::iterator i;

  for (i=j.begin(); i!=j.end(); ++i) {
    if (!stricmp(title,i->title.c_str()))
    return i; //apparently I can't return the index. We'll see how important
              //that is.
  }
  return j.end(); //badness.
}
#endif

//return index of record with title. -1 if nonesuch.
_f int findpw_record(const char *title) {
  int i;

  for (i=0; i< int(Gthelist.size()); ++i) {
    if (!stricmp(Gthelist[i].title.c_str(),title))
    return i;
  }

  return -1;

}



/****************************************************************************
****************************************************************************/
_f void begin_ipw(void) {
  static bool begun;
  if (begun)
  return;

  begun = true;

#if RIJ_ENC0
  rijate();
#endif

  getoptions();
}

/****************************************************************************
****************************************************************************/
_f jpw *blankjpw(void) {
  static jpw blank;

  if (blank.title=="") {    //init if necessary.
    blank.title =
    blank.login =
//    blank.password =
    blank.misc =
    blank.execute =
    blank.comment =
    "?????";
  }
  return &blank;

}

_f jpw *examplejpw(void) {
  static jpw example;
  if (example.title=="") {    //init if necessary.
    example.title = "An Example Password Record";
    example.login = "Your Name or Login";
    example.password = "Your Password";
    example.misc =     "miscellaneous drivel";
    example.execute =  "www.anywhere.com";
    example.comment = "You can edit these things if you uncheck \"protect\" "
    "in the passwords menu. And see the help.";
  }
  return &example;
}

/****************************************************************************
****************************************************************************/
bool jpw::operator==(jpw &a) {
  return
  (title == a.title) &&
  (login == a.login) &&
  (password == a.password) &&
  (misc == a.misc) &&
  (execute == a.execute) &&
  (comment == a.comment);
}

bool jpw::operator!=(jpw &a) {
  return
  !(operator==(a));
}

jpw::~jpw(void) {
}

/****************************************************************************
****************************************************************************/
#define RANDOM(x) (rand() % x)

static char randchar(void) {
  return
  RANDOM(26)+'A';
}

static char randchar_number(void) {
  int i = RANDOM(46); //make more numbers.

  if (i<26)
  return i+'A';

  return ((i-26) % 10) + '0';
}

_f string random_password(void) {
#define PW_SIZE (15)
  string s;
  int i=1;

#ifdef _MSC_VER
  srand(GetTickCount());
#else
//  randomize();
  srand(time(NULL));
#endif

  s = randchar();

  for ( ; i<PW_SIZE; ++i)
  s += randchar_number();

  return s;

}

/****************************************************************************
search thru Gthelist for text. Don't login_password if not true. Returns -1 if
nothing found.
_copy
int search(int startindex, bool login_password, char *what, char
**section=NULL);
_uncopy
****************************************************************************/
int search(int startindex, bool login_password, char *what, char **section) {
  int i;
  char *w;

  if (startindex<0)
  startindex = 0;

  for (i=startindex; i<int(Gthelist.size()); ++i) {
    if (
    (w="title", stristr(Gthelist[i].title.c_str(),what)) ||

    (w="login",
    (stristr(Gthelist[i].login.c_str(),what) && login_password)) ||

    (w="password",
    (stristr(Gthelist[i].password.c_str(),what) && login_password)) ||

    (w="miscellany", stristr(Gthelist[i].misc.c_str(),what)) ||
    (w="url/exec", stristr(Gthelist[i].execute.c_str(),what)) ||
    (w="comment", stristr(Gthelist[i].comment.c_str(),what))
    ) {
      if (section)
      *section = w;
      return i;
    }
  }

  return -1;

}

/****************************************************************************
****************************************************************************/

_f string httpize(const char *what) {
  string d(what);

  while(isspace(d[0]))
  d.erase(0,1);   //trim spaces from front.

  if (!strnicmp(d.c_str(),"www.",4))
//  d = (string) "http://"+d;
  d.insert(0,"http://");

  return d;
}

/****************************************************************************
****************************************************************************/

_v char THEKEY[] = "we'll use the same key";
//not used by mac program I think. Sloppy sloppy....

_v int from_list_count; //mutilated by crypt code.

/****************************************************************************
****************************************************************************/

