/****************************************************************************
ipwsbrs.cpp
Wed 4/04/2007 11:43 am  creation from ogsbrs.cpp.

This is supposed to be the general-purpose version; a la my sainted sbrs.c. //
Well actually of course in each case it'll get copied somewhere mutilated etc.
I dunno might copy the thing back or somehow or something.... I could just
stick them in sbrs.c I suppose.... Whatever....

Wed 5/09/2007 1:30 pm. Removed jstringicmp. I wrote it because I thought
stricmp had disappeared forever, but it turned-out a sad latter-day version is
strcasecmp -- a truly idiotic name but what the heck.

****************************************************************************/

/****************************************************************************
****************************************************************************/

#include <stdio.h>
#include <stdexcept>
#include "jini.h"         //the ini file h thingey?
#include "ipw.h"          //this program.

using namespace jIni_space;
using namespace std;

/****************************************************************************
****************************************************************************/


#if j_WIN
char Gslashcharacter = '\\';
char Gslashs[] = "\\";
#endif

#if j_MAC
_v char Gslashcharacter = '/';
_v char Gslashs[] = "/";
#endif

static string slashpgmdir;


/****************************************************************************
can't be "const string &s" because s.end() somehow modifies the thingey?
****************************************************************************/
_f char jlastchar(string s) {
  if (!s.length())
  return 0;

/****************************************************************************
Mon 8/13/2007 10:47 am. Found this in the managed C++ .net version,
command-line only. I.e., in that environment it would only crash on the
command line, so I had to sprinkle the source with "printfs" -- which were
difficult to institute in and of themselves! ... Anyway, in its crude
insensitive fashion it was perfectly correctly; I *shouldn't've* decremented
an iterator of an empty string -- it was already at the end. And it's entirely
possible, due to moon-phase problems, that the empty string didn't turn-up in
the command-line version.
****************************************************************************/

  string::iterator i = s.end();

  return *(--i);
}

_f string jslash(string s) {

  if (jlastchar(s)!=Gslashcharacter) {
    return s + Gslashcharacter;
  }

  return s;
}

_f string junslash(string s) {
  string::iterator i = s.end();

  if (*(--i)==Gslashcharacter)
  s.erase(i);

  return s;
}


//return the front of a path, and the last element in it.
_f void jsplit_path(string path, string &front, string &last) {
  string::size_type i;

  path = junslash(path);

  if (
  (!path.length()) ||                //no string.
  (
  (i = path.find_last_of(
  Gslashcharacter
  ))==string::npos                //no slash
  )
  ) {
    last = path;
    front = "";
    return;
  }

  front = path.substr(0,i+1);
  last = path.substr(i+1);

}

_f string jlast_path(string path) {
  string front, last;
  jsplit_path(path,front,last);
  return last;
}

_f void jsplit_ext(const string path, string &front, string &ext) {
  string::size_type
  islash, idot;

  if ((islash = path.find_last_of(Gslashcharacter))==string::npos)
  islash = 0;     //pretend it's at the beginning.

  idot   = path.find_last_of('.');

  if (
  (idot==string::npos) ||
  (idot < islash) ||      //dot not part of filename part.
  (!idot)             //let's special-case a filename beginning with a dot.
  ) {
    front = path;
    ext = "";     //no extension.
    return;
  }

  front = path.substr(0,idot);
  ext = path.substr(idot);       //include dot.

}

_f char *re_ext(const char *p, const char *e) {
  string front, ext;

  jsplit_ext(p,front,ext);

  return
  strdup( (front + e).c_str());

}

_f string jpgmdir(void) {
  string dummy;

  if (!slashpgmdir.length())
  jsplit_path(__Jargv[0],slashpgmdir,dummy);

  return slashpgmdir;

}

_f string jpgmdirize(const string &s) {
  return jpgmdir() + s;
}

#if 0
int jstringicmp(const string &one, const string &two) {
  return stricmp(two.c_str(),one.c_str();
}
#endif

_f void getreturn(void) {
  char abuf[3];
  fgets(abuf,2,stdin);
}

//produces allocated cwd; must be freed.
_f char *j_cwd(void) {
  char *s, *x;
  s = strdup(x=getcwd(NULL,MAXPATH+2));
  free(x);
  return s;
}

/****************************************************************************
****************************************************************************/
#if j_MAC
_f string dehomeize(string s) {
  char *p;

  if (s.substr(0,1)=="~") { //magic only FIRST character see?
    if (p=getenv("HOME"))
    return
    string(p) + s.substr(1,5000);
  }

  return s;

}
#endif

/****************************************************************************
returns true path or something of what.
****************************************************************************/
_f string j_path(string what) {
#if j_MAC
  what = dehomeize(what);  //realpath doesn't know about ~?

  char r[PATH_MAX+2], *p = realpath(what.c_str(),r);
  if (p)
  what = p;

  return what;
#endif

#if j_WIN
  char r[MAXPATH+2], *n;

  if (
#if DOT_NET
  GetFullPathNameA
/****************************************************************************
Thu 8/09/2007 12:29 pm. [before I did this] Instead I changed project
"properties / general / character set" from "use unicode character set" to
"use multi-byte character set" as per a hint on some microsoft website. I have
no idea of what that means.

Mon 8/13/2007 2:45 pm. So seemingly GetFullPathNameA fixes it?!?! Wow have I
got a lot to learn! ... Well I suppose it makes perfect sense; the unicode
version of the program *defaults* to the "W" version. So this *is* the right
fix.....
****************************************************************************/

#else
  GetFullPathName
#endif
  (
  what.c_str()

  ,MAXPATH,r,&n))
  what = r;
  //else what remains what it was.

  return what;

#endif

}

_f string IntToHexString(const int &i) {
  std::stringstream myStream;

  myStream << hex << i;

  return myStream.str();

}

_f string IntToOctString(const int &i) {
  std::stringstream myStream;

  myStream << oct << i;

  return myStream.str();

}

//get environment thingey, but if nonesuch, return empty string.
//useful for initializing strings, which react poorly to NULL.
_f char *jgetenv(const char *what) {
  char *p = getenv(what);

  if (!p)
  return "";

  return p;

}

//free p IF non-NULL, and then dup what to p.
_f void free_cstr_dup(char **p, const char *what) {

  if (*p)
  free(*p);

  *p = strdup(what);
}

_f bool isdir(const char *p) {
  struct stat statbuf;

  return
  (!stat(p,&statbuf)) &&
  ((statbuf.st_mode & S_IFMT) == S_IFDIR)
  ;

}

/* return nz if file name exists. evades append. */
_f int exist(const char *name) {
  return !access(name,0);
}


_f string decontrol(const string &s) {
  unsigned int i;
  string d;

  for (i=0; i<s.size(); ++i) {
    if (s[i]>=' ')
    d += s[i];
  }
  return d;
}

_f char *stristr(const char *t, const char *what) {
  int length;
  char *target = (char *) t;

  if (length=strlen(what)) {
    while (*target) {
      if (!(strnicmp(target,what,length)))
      return target;
      ++target;
    }
  }
  return NULL;
}

/****************************************************************************
And old fashioned by still handy function; used by various test functions in
the command-line test version of ipw.
****************************************************************************/

_f void mustopen(FILE **f, char *name, char *mode) {
  if (!(*f=fopen(name,mode))) {
    fprintf(stderr,"couldn't open %s for %s.",name,mode);
    exit(3);
  }
}


