/****************************************************************************
tripe.h
Wed 5/09/2007 11:42 am  creation from ipw.h

Try to keep weird stuff in here, although I know it'll be hard. I.e., the
endless distinctions between poor ol' Borland Builder version 5 and 2005
Visual Studio for instance. I don't really plan any rhyme or reason for these;
that is, the j_WIN section'll probably do microsoft and then the more rational
compilers.... Sorry....

****************************************************************************/

#ifndef TRIPE_H
#define TRIPE_H

/****************************************************************************
****************************************************************************/
#include "winix.h"    //contains def for j_WIN or j_MAC, set manually.

/****************************************************************************
****************************************************************************/
#if j_WIN

#ifdef _MSC_VER


  #define MICROSOFT (1)

  #include <conio.h>
  #include <direct.h>

//  #include <stdlib.h>
  #include <io.h>
//ok I guessed which include file I need for _access.

//now we'll look for STL sort.
  #include <algorithm>  //Bingo!

  #ifndef MAXPATH
    #define MAXPATH _MAX_PATH
  #endif
  #include <windows.h>
  /****************************************************************************
  UNRESOLVED EXTERNAL SYMBOL _WINMAIN@16                  Wed 5/09/2007 12:57 pm

  In visual studio of course.

  1. In solution explorer, *Right-click* on "ipw_vs", select "properties".

  2. "Configuration Properties" "Linker" "System"

  3. Then in the right pane you select "SubSystem". It probably says "Windows
  (/SUBSYSTEM:WINDOWS)". With the drop down thingey, change it to "Console
  (/SUBSYSTEM:CONSOLE)".

  And then it compiles....

  ... So I suspect it decided it was windows because somewhere in the program I
  included "windows.h" so I'm going to put this note there. Visual Studio
  2005.

  Also while I'm here I should note that I did *not* get rid of all Visual
  Studio Warnings, because they were just too stupid. fopen for instance is
  deprecated.
  ****************************************************************************/

//  #define _CRT_SECURE_NO_WARNINGS (1) //screw it; they're just silly.
//didn't work; let's try
  #pragma warning( disable : 4996 ) //seemed to work.

  #define getcwd _getcwd
  #define strdup _strdup
  #define unlink _unlink
  #define strdup _strdup
  #define stricmp _stricmp
  #define strnicmp _strnicmp  //?
  #define access _access

#else //_MSC_VER

/****************************************************************************
Other winders -- probably borland builder version 5. .... well or GNU c.
****************************************************************************/

  #include <dir.h>
//  #include <dirent.h>
  #include <conio.h>
  #ifndef MAXPATH
    #define MAXPATH MAX_PATH
  #endif
  #ifdef __GNUC__         //or a little GNU.
    #include <windows.h>
/****************************************************************************
Wed 3/14/2007 1:28 pm. To get the ming compiler to do Windows GetFullPathName
I use the __GNUC__ thingey. I tried <winbase.h> but that just makes a million
errors. Including windows.h in everything is costly, but then again I'd just
as soon force errors for everyone at the same time -- and what is time to the
iMini?
****************************************************************************/
  #endif
#endif

  #include <sys\stat.h>

#endif  //_MSC_VER

/****************************************************************************
****************************************************************************/
#if j_MAC   //Macintosh X10 BSDish unix.

  #ifndef MAXPATH
    #include <sys/syslimits.h>
    #define MAXPATH PATH_MAX
  #endif

  #include <sys/stat.h>

#endif

/****************************************************************************
****************************************************************************/

#ifdef __GNUC__     //you understand, we might use GNUC on Mac *and* winders.

  #if __GNUC__ >= 4
    #define stricmp strcasecmp
    #define strnicmp strncasecmp
  #endif

#endif

/****************************************************************************
And now ... the lovely and gracious .NET environment! I'm trying to get some
kind of debug working up here....
****************************************************************************/

#ifdef __cplusplus_cli    //.NET!

  using namespace System::Diagnostics;
  #define DOT_DEBUG Debug::WriteLine  //so u go DEBUG("bingo bongo");
//so this isn't used; I figured-out -- from the web -- how to printf. Yay!

  #define DOT_NET (1)   //My conditional; might need it.

#else

  #define DOT_NET (0)
  #define DOT_DEBUG // a comment.

#endif


/****************************************************************************
****************************************************************************/
#endif  //#ifdef TRIPE_H.
